function [] = masteqn_avghp1(GEN,SNAPi,SNAPf,SNAPstep,HP1,AD0)

close all

rng shuffle
S = rng;
seed = S.Seed;

str = char('input/gen%d/r%dv%d/hp1prof.mat');
filename = sprintf(str,GEN,SNAPi,HP1);
load(filename)

% Parameters
% A = reaction radius in nm
NN = length(hp1prof); % number of nucleosomes
% AD0 = bare relative rate of methylation (KM0/KD)
% AD = relative rate of methylation (KM/KD)

NHNsum = 0; 
count = 0;

for SNAP = SNAPi:SNAPstep:SNAPf
    % Load file
    str = char('input/gen%d/r%dv%d/hp1neigh.mat');
    filename = sprintf(str,GEN,SNAP,HP1);
    load(filename)
    
    NHNsum = NHNsum + NHNsnap;
    count = count + 1;
end

NHNavg = NHNsum/count; % average number of neighbors with HP1 bound

AD = NHNavg*AD0; % effective methylation rate

% Solve for steady-state probabilities of methylation
PM = AD./(AD+ones(NN,1));

% Randomly select methylation status
R1 = rand(NN,1);
R2 = rand(NN,1);
MS1 = zeros(NN,1);
MS2 = zeros(NN,1);
MS1(R1 < PM) = 1;
MS2(R2 < PM) = 1;
MS = MS1 + MS2; 

save(['data/gen',num2str(GEN),'/v',num2str(HP1),'/ad',num2str(AD0),'.mat'],'NN','AD','AD0','NHNavg','PM','MS','SNAPi','SNAPf','SNAPstep','seed','-v7.3')
dlmwrite(['data/gen',num2str(GEN),'/v',num2str(HP1),'/methfinal_ad',num2str(AD0),'.txt'],MS)
    

end

