program main
use binning
implicit none
type(binType) bin
double precision radius
integer NT
double precision, allocatable, dimension(:,:):: R
double precision, allocatable, dimension(:,:):: IM
integer ii,jj

double precision setBinSize(3)
integer setBinShape(3)
double precision maxvals(3)
double precision minvals(3)
double precision sideLength

integer, parameter :: maxNeighbors=100
integer nNeighbors !number of neighbors found (so far)
integer neighbors(maxNeighbors) ! list of bead ID's
double precision distances(maxNeighbors) ! list of |r-r| values
integer exclude


NT=393216
allocate(R(NT,3))
allocate(IM(NT,5))

open(1,file="infile")
do ii=1,NT
    read(1,*) R(ii,:)
enddo
close(1)

open(1,file='infile')
do ii=1,NT
    read(1,*) IM(ii,:)
enddo 
close(1)


maxvals=maxval(R,1)
minvals=minval(R,1)
sideLength=maxval(maxvals-minvals,1)+0.02
minvals=minvals-0.01
setBinSize = [sideLength, sideLength, sideLength]
setBinShape = [6,6,6]
call constructBin(bin,setBinShape,minvals,setBinSize)


do ii=1,NT
    call addBead(bin,R,NT,ii)
enddo

radius=0.523
exclude=1

print*, 'now find neighbors...'
open(2,file='neighborList')
open(3,file='numNeighbors')
open(4,file='hp1Sequence')
do ii=1,NT
    nNeighbors=0
    call findNeighbors(bin,R(ii,:),radius,R,NT,&
                          maxNeighbors,neighbors,distances,nNeighbors)
    do jj=1,nNeighbors
        if (abs(ii-neighbors(jj))<1) then
            cycle
        endif
        write(2,*) ii,neighbors(jj), distances(jj)
    enddo

    write(3,*) nNeighbors-1
    write(4,*) IM(ii,4)
enddo
close(2)
close(3)
close(4)

end program
